/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.part;

import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPMenuConst;
import jp.mosp.common.dao.CmAuthorityDao;
import jp.mosp.common.dto.CmAuthorityDto;
import jp.mosp.common.dto.CmComponentDto;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.VariousUtil;

/**
 * 権限に関するPartクラス
 * @author yoshida
 *	@version	0.0.3
 */
public class AuthorityPart extends BasePart {
	
	/**
	 * コンストラクタ
	 */
	public AuthorityPart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo	Partを利用する際に必要な情報
	 */
	public AuthorityPart(PartInfo partInfo) {
		super(partInfo);
	}
	

	/**
	 * CmAuthorityDaoインスタンス
	 */
	private CmAuthorityDao	authorityDao;
	

	/**
	 * CM_AUTHORITYテーブル用のDAO取得
	 * @return	初期化済みCmAuthorityDaoインスタンス
	 * @throws Exception 例外処理が発生した場合
	 */
	public CmAuthorityDao getCmAuthorityDao() throws Exception {
		if (VariousUtil.isNull(authorityDao)) {
			authorityDao = (CmAuthorityDao)getPreparedDao(CmAuthorityDao.class.getCanonicalName());
		}
		return authorityDao;
	}
	
	/**
	 * 権限情報の取得
	 * @param userAuth	対象権限コード
	 * @return			権限情報
	 * @throws Exception 例外処理が発生した場合
	 */
	public CmAuthorityDto findForKey(String userAuth) throws Exception {
		return getCmAuthorityDao().findForKey(userAuth);
	}
	
	/**
	 * 権限コードリスト取得(CM_AUTHORITY)
	 * @return コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getArrangeAuthArray() throws Exception {
		// データの取得
		List<CmAuthorityDto> list = getCmAuthorityDao().findForAvailable();
		// データの整形
		String[][] array = new String[list.size()][2];
		for (int i = 0; i < array.length; i++) {
			CmAuthorityDto dto = list.get(i);
			array[i][0] = dto.getAuthCode();
			array[i][1] = dto.getAuthName();
		}
		return array;
	}
	
	/**
	 * 全権限コードリスト取得(CM_AUTHORITY)
	 * @return コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getArrangeAuthArrayAll() throws Exception {
		// データの取得
		List<CmAuthorityDto> list = getCmAuthorityDao().findAll();
		// データの整形
		String[][] array = new String[list.size()][2];
		for (int i = 0; i < array.length; i++) {
			CmAuthorityDto dto = list.get(i);
			array[i][0] = dto.getAuthCode();
			array[i][1] = dto.getAuthName();
		}
		return array;
	}
	
	/**
	 * MANAGER権限確認
	 * @return MANAGER権限有無(true：権限有、false：権限無)
	 * @throws Exception 例外処理が発生した場合
	 */
	public boolean hasManagerAuth() throws Exception {
		// MANAGER権限確認
		String authority = user.getAuthority();
		CmAuthorityDto dto = findForKey(authority);
		String managerAuth = "";
		if (VariousUtil.isNotNull(dto)) {
			managerAuth = dto.getManager();
		} else if (isManagerAuth(authority) || isSeniorAuth(authority)) {
			// デフォルトコードの設定
			managerAuth = CommonConst.CONF_ID_MANAGER;
		}
		if (StringUtil.isNotNull(managerAuth)) {
			return true;
		}
		return false;
	}
	
	/**
	 * PAYROLL権限確認
	 * @return PAYROLL権限有無(true：権限有、false：権限無)
	 * @throws Exception 例外処理が発生した場合
	 */
	public boolean hasPayrollAuth() throws Exception {
		// PAYROLL権限確認
		String authority = user.getAuthority();
		String payrollAuth = "";
		CmAuthorityDto dto = findForKey(authority);
		if (VariousUtil.isNotNull(dto)) {
			payrollAuth = dto.getPayroll();
		} else if (isPayrollAuth(authority) || isSeniorAuth(authority) || isCalculateAuth(authority)) {
			// デフォルトコードの設定
			payrollAuth = CommonConst.CONF_ID_PAYROLL;
		}
		if (StringUtil.isNotNull(payrollAuth)) {
			return true;
		}
		return false;
	}
	
	/**
	 * HUMAN権限確認
	 * @return HUMAN権限有無(true：権限有、false：権限無)
	 * @throws Exception 例外処理が発生した場合
	 */
	public boolean hasHumanAuth() throws Exception {
		// HUMAN権限確認
		String userAuth = user.getAuthority();
		String humanAuth = "";
		CmAuthorityDto dto = findForKey(userAuth);
		if (VariousUtil.isNotNull(dto)) {
			humanAuth = dto.getHuman();
		} else if (isHumanAuth(userAuth) || isSeniorAuth(userAuth)) {
			// デフォルトコードの設定
			humanAuth = CommonConst.CONF_ID_HUMAN;
		}
		if (StringUtil.isNotNull(humanAuth)) {
			return true;
		}
		return false;
	}
	
	/**
	 * CALCULATE権限確認
	 * @return CALCULATE権限有無(true：権限有、false：権限無)
	 * @throws Exception 例外処理が発生した場合
	 */
	public boolean hasCalculateAuth() throws Exception {
		// CALCULATE権限確認
		String userAuth = user.getAuthority();
		CmComponentDto componentDto = null;
		CmAuthorityDto authorityDto = findForKey(userAuth);
		if (VariousUtil.isNotNull(authorityDto)) {
			componentDto = part().component().findForDto(authorityDto.getPayroll(), CommonConst.CONF_ID_PAYROLL);
		}
		if (isCalculateAuth(userAuth)) {
			// デフォルトコードの設定
			if (VariousUtil.isNull(authorityDto)) {
				componentDto = part().component()
					.findForDto(CommonConst.CONF_ID_CALCULATE, CommonConst.CONF_ID_PAYROLL);
			}
			// デフォルトコードの設定
			if (VariousUtil.isNull(componentDto)) {
				componentDto = new CmComponentDto();
				componentDto.setComponent(MosPMenuConst.getMenuAttendanceCalculateStart()[0]);
			}
		}
		if (VariousUtil.isNotNull(componentDto)) {
			String[] aryCmd = StringUtil.divideByComma(componentDto.getComponent());
			for (String element : aryCmd) {
				if (element.equals(MosPMenuConst.getMenuAttendanceCalculateStart()[0])
						|| element.equals(MosPMenuConst.getMenuAttendanceCalculateEnd()[0])
						|| element.equals(MosPMenuConst.getMenuKeisanInformation()[0])
						|| element.equals(MosPMenuConst.getMenuExport()[0])) {
					return true;
				}
			}
		}
		return false;
	}
	
	/**
	 * SYSTEM権限確認
	 * @return SYSTEM権限有無(true：権限有、false：権限無)
	 */
	public boolean hasSystemAuth() {
		// ADMIN権限確認
		return isSystemAuth(user.getAuthority());
	}
	
	/**
	 * 権限別DTO取得
	 * @since	0.0.2
	 * @return 権限DTO
	 * @throws Exception 例外処理が発生した場合
	 */
	public CmAuthorityDto getUserAuthDto() throws Exception {
		return getCmAuthorityDao().findForAuth(user.getAuthority());
	}
	
	/**
	 * MANAGER権限確認
	 * @since	0.0.3
	 * @param authority	対象プログラム利用権限コード
	 * @return	MANAGER権限の場合true、そうでない場合false
	 */
	public static boolean isManagerAuth(String authority) {
		return CommonConst.AUTHORITY_MANAGER.equals(authority);
	}
	
	/**
	 * 給与権限確認
	 * @since	0.0.3
	 * @param authority	対象プログラム利用権限コード
	 * @return	給与権限の場合true、そうでない場合false
	 */
	public static boolean isPayrollAuth(String authority) {
		return CommonConst.AUTHORITY_PAYROLL.equals(authority);
	}
	
	/**
	 * HUMAN権限確認
	 * @since	0.0.3
	 * @param authority	対象プログラム利用権限コード
	 * @return	HUMAN権限の場合true、そうでない場合false
	 */
	public static boolean isHumanAuth(String authority) {
		return CommonConst.AUTHORITY_HUMAN.equals(authority);
	}
	
	/**
	 * 人事給与権限確認
	 * @since	0.0.3
	 * @param authority	対象プログラム利用権限コード
	 * @return	人事給与権限の場合true、そうでない場合false
	 */
	public static boolean isSeniorAuth(String authority) {
		return CommonConst.AUTHORITY_SENIORS.equals(authority);
	}
	
	/**
	 * 計算権限判断
	 * @since	0.0.3
	 * @param authority	対象プログラム利用権限コード
	 * @return	計算権限の場合true、そうでない場合false
	 */
	public static boolean isCalculateAuth(String authority) {
		return CommonConst.AUTHORITY_CALCULATE.equals(authority);
	}
	
	/**
	 * SYSTEM権限判断
	 * @since	0.0.3
	 * @param authority		対象プログラム利用権限コード
	 * @return SYSTEM権限の場合true、そうでない場合false
	 */
	public static boolean isSystemAuth(String authority) {
		// ADMIN権限確認
		return CommonConst.AUTH_SYSTEM.equals(authority);
	}
	
}
